import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.applet.Applet;
import java.net.*;
import java.awt.image.*;

public class gui extends JPanel implements ActionListener {
	private static void createAndShowGUI(String root) {
		JFrame.setDefaultLookAndFeelDecorated(true);
		JFrame frame = new JFrame("X-CORHEL");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JLabel label = new JLabel("X-CORHEL");

		JComponent newContentPane = new gui(root);
		newContentPane.setOpaque(true);
		newContentPane.setBorder(BorderFactory.createRaisedBevelBorder());
		frame.setContentPane(newContentPane);

		frame.pack();
		frame.setVisible(true);
	}

	gui corhelGui;
	Timer t;
	JTextField ebMinBox, ebMaxBox, ePointBox, scaleMinBox, scaleMaxBox, crBox;
	JComboBox resBox,palBox,obsBox,mmmaxBox; 
	String[] resNum,palettes,paletteNames,observatory,mmmaxNum;
	ImageIcon rawII, masinII, westAxisII, wwestAxisII, southAxisII, ssouthAxisII ;
	JLabel raw, masin, westAxis, wwestAxis, southAxis, ssouthAxis ;
	int CR ;
	String RES ;
	JProgressBar jpb;
	int scale;
	//JProgressBar proBar;
	String root_path;
	float hdf_min, hdf_max;
	JComponent coronalOps, helioOps, helpWindow;
	JFrame coronaFrame, helioFrame, helpFrame;
	JButton processButton, resetButton, helpButton, quitButton, helio, bcs, crhl;

	public void go() {
		rawII = null;
		masinII = null;	
		rawII = new ImageIcon(root_path + "/run/cr"+ CR + "-" + RES + "/movie/raw" + CR + RES + ".gif");
		masinII = new ImageIcon(root_path + "/run/cr"+ CR + "-" + RES + "/movie/masin" + CR + RES + ".gif");
/*
		while (rawII.getImageLoadStatus() != MediaTracker.COMPLETE || masinII.getImageLoadStatus() != MediaTracker.COMPLETE) {
			//Stall
			System.out.println("Loading Images");
		}
*/
		if (obsBox.getSelectedIndex() == 1) {
			rawII.setImage((rawII.getImage()).getScaledInstance(scale,scale,Image.SCALE_FAST));
			rawII.setImage(rotate(rawII.getImage(),scale,scale));
		}

		rawII.setImage((rawII.getImage()).getScaledInstance(scale,scale/2,Image.SCALE_FAST));
		masinII.setImage((masinII.getImage()).getScaledInstance(scale,scale,Image.SCALE_FAST));
		masinII.setImage(rotate(masinII.getImage(),scale,scale));
		masinII.setImage((masinII.getImage()).getScaledInstance(scale,scale/2,Image.SCALE_FAST));

		rawII.getImage().flush();
		masinII.getImage().flush();

		raw.setIcon(rawII);
		masin.setIcon(masinII);
		
		//Repaint
		this.repaint(new  Rectangle(0,0,800,800));
	}

	public gui (String rute) {
		super(new BorderLayout());

		//Set Root Path
        root_path = rute;	
		hdf_min = -40;
		hdf_max = 40;
		// res 

		//Initialize windows for Options
		//Create Window for Coronal Options
        coronaFrame = new JFrame("Coronal Options");
        coronalOps = new coronalOptions(coronaFrame);
        coronalOps.setOpaque(true);
        coronalOps.setBorder(BorderFactory.createRaisedBevelBorder());
        coronaFrame.setContentPane(coronalOps);
        coronaFrame.pack();
        coronaFrame.setVisible(false);

        //Create Window for Heliospheric Options
        helioFrame = new JFrame("Heliospheric Options");
        helioOps = new helioOptions(helioFrame);
        helioOps.setOpaque(true);
        helioOps.setBorder(BorderFactory.createRaisedBevelBorder());
        helioFrame.setContentPane(helioOps);
        helioFrame.pack();
        helioFrame.setVisible(false);

		//Create Help Window
        helpFrame = new JFrame("Help Window");
        helpWindow = new helpMenu(helpFrame, root_path);
        helpWindow.setOpaque(true);
        helpWindow.setBorder(BorderFactory.createRaisedBevelBorder());
        helpFrame.setContentPane(helpWindow);
        helpFrame.pack();
        helpFrame.setVisible(false);

		observatory = new String[2];
		observatory[0] = "Kittpeak/Solis";
		observatory[1] = "Wilcox";

		obsBox = new JComboBox(observatory);
		obsBox.setSelectedIndex(0);
		obsBox.addActionListener(this);
		

		resNum = new String[2];
		resNum[0] = "low";
		resNum[1] = "medium";

		resBox = new JComboBox(resNum);
		resBox.setSelectedIndex(0);
		resBox.addActionListener(this);
		
		// now add the combo box
/*		crNum = new String[2007-1624];
		int i;
		for (i=0; i < (2007-1624) ; i++) {
			crNum[i] = Integer.toString(1625+i);
		}
		crBox = new JComboBox(crNum);
		crBox.setSelectedIndex(1913-1625);
		crBox.addActionListener(this);
*/
		//Must Clamp crBox to be between 1625 & 2007
		crBox = new JTextField("1913");
		crBox.addActionListener(this);		

		// mmmax box
		mmmaxNum = new String[21];
		for (int i=0; i < 21; i++) {
			mmmaxNum[i] = Integer.toString(i);
		}
		mmmaxBox = new JComboBox(mmmaxNum);
		mmmaxBox.setSelectedIndex(9);
		mmmaxBox.addActionListener(this);

		// extrapolation boxes
/*		ebMinNum = new String[1571];
		ebMaxNum = new String[1571];
		ePointNum = new String[1571];

		double j;
		Integer ii;
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(3);
		for (i=0; i < 1571 ; i++) {
			j = ((double)i) * .001;
			ebMinNum[i] = nf.format(j);
			ebMaxNum[i] = nf.format(j);
			ePointNum[i] = nf.format(j);
		}

		ebMinBox = new JComboBox(ebMinNum);
		ebMinBox.setSelectedIndex(250);
		ebMinBox.addActionListener(this);
		ebMaxBox = new JComboBox(ebMaxNum);
		ebMaxBox.setSelectedIndex(450);
		ebMaxBox.addActionListener(this);
		ePointBox = new JComboBox(ePointNum);
		ePointBox.setSelectedIndex(350);
		ePointBox.addActionListener(this);
*/		
		//Note Range Must be clamped between 0 and 1.57
		ebMinBox = new JTextField("0.25");
		ebMinBox.addActionListener(this);
		ebMaxBox = new JTextField("0.45");
		ebMaxBox.addActionListener(this);
		ePointBox = new JTextField("0.35");
		ePointBox.addActionListener(this);

/*
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(3);
		double j;

		// scale boxex
		scaleMinNum = new String[101];
		scaleMaxNum = new String[101];
		nf.setMaximumFractionDigits(2);
		for (i=0; i < 101 ; i++) {
			j = ((double)i) * .01;
			scaleMinNum[i] = nf.format(j);
			scaleMaxNum[i] = nf.format(j);
		}

		scaleMinBox = new JComboBox(scaleMinNum);
		scaleMinBox.setSelectedIndex(0);
		scaleMinBox.addActionListener(this);
		scaleMaxBox = new JComboBox(scaleMaxNum);
		scaleMaxBox.setSelectedIndex(100);
		scaleMaxBox.addActionListener(this);
*/
		//Note: Scale Min must be less than Scale Max
		scaleMinBox = new JTextField(Float.toString(hdf_min));
		scaleMinBox.addActionListener(this);
		scaleMaxBox = new JTextField(Float.toString(hdf_max));
		scaleMaxBox.addActionListener(this);

		// now add the palete box
		palettes = new String [] {"EIT171.pal", "EIT195.pal","EIT284.pal" ,"EIT_green.pal", "EIT_blue.pal",
			"EIT_yellow.pal", "bluewhite.pal", "bluewhite_lowblack.pal", "hotmetal.pal", "seismic.pal", 
			"seismic_lowblack.pal", "rainbow.pal", "rainbow_lowblack.pal", "banded.pal", "banded_lowblack.pal",
			"contour.pal", "volcano.pal", "gray.pal", "saturn.pal"};
		paletteNames = new String[] {"EIT 171", "EIT 195", "EIT 284", "EIT Green", "EIT Blue", "EIT Yellow",
			"Blue & White", "Blue & White: Low Black", "Hot Metal", "Seismic", "Seismic: Low Black", "Rainbow",
			"Rainbow: Low Black", "Rainbow Banded", "Rainbow Banded: Low Black", "B&W Contour", "Volcano",
			"Gray Scale", "Saturn"};
		
		palBox = new JComboBox(paletteNames);
		palBox.setSelectedIndex(9);
		palBox.addActionListener(this);
		
		//Processing Button
		processButton = new JButton("Process Input");
		processButton.setActionCommand("process");
		processButton.addActionListener(this);

		//Help Button
		helpButton = new JButton("Help");
		helpButton.setActionCommand("help");
		helpButton.addActionListener(this);

		//Quit Button
		quitButton = new JButton("Quit");
		quitButton.setActionCommand("quit");
		quitButton.addActionListener(this);

		//Reset Button
		resetButton = new JButton("Reset");
		resetButton.setActionCommand("reset");
		resetButton.addActionListener(this);

		// bcs button
		bcs = new JButton("Coronal Options");
		bcs.setActionCommand("corona");
		bcs.addActionListener(this);

		// helio button
		helio = new JButton("Heliospheric Options");
		helio.setActionCommand("helio");
		helio.addActionListener(this);
		//helio.setPreferredSize(new Dimension(20,10));
		
		// corhel button 
		crhl = new JButton("Run Corhel");
		crhl.setActionCommand("corhel");
		crhl.addActionListener(this);
		//crhl.setPreferredSize(new Dimension(10,20));

/*
		// text area
		JTextArea mmmax = new JTextArea("9",1,2);
		JTextArea ebMin = new JTextArea(".25",1,5);
		JTextArea ebMax = new JTextArea(".45",1,5);
		JTextArea ePoint = new JTextArea(".35",1,5);
*/
		// labels
		JLabel obsLabel = new JLabel("Observatory");
		JLabel rawLabel = new JLabel("Raw Image",JLabel.CENTER);
		JLabel masinLabel = new JLabel("MAS Input",JLabel.CENTER);
		JLabel crBoxLabel = new JLabel("Carrington Rotation");
		JLabel resBoxLabel = new JLabel("Resolution");
		JLabel palBoxLabel = new JLabel("Palette");
//		JLabel bcsLabel = new JLabel("Process input bcs: corona");
//		JLabel helioLabel = new JLabel("Process input bcs: helio");
		JLabel crhlLabel = new JLabel("Run Coronal and Heliospheric Models",JLabel.CENTER);
		JLabel sizeLabel = new JLabel("Image Size");
		JLabel mmmaxLabel = new JLabel("Max Mode");
		JLabel ebMinLabel = new JLabel("Extrapolation Band Min");
		JLabel ebMaxLabel = new JLabel("Extrapolation Band Max");
		JLabel ePointLabel = new JLabel("Extrapolation Point");

		// starting size is in the middle
		scale = 400;
		// images
		rawII = new ImageIcon("./gif/raw.gif");
		masinII = new ImageIcon("./gif/masin.gif");
		rawII.setImage((rawII.getImage()).getScaledInstance(scale,scale/2,Image.SCALE_FAST));
		masinII.setImage((masinII.getImage()).getScaledInstance(scale,scale,Image.SCALE_FAST));
		masinII.setImage(rotate(masinII.getImage(),scale,scale));
		masinII.setImage((masinII.getImage()).getScaledInstance(scale,scale/2,Image.SCALE_FAST));

		raw = new JLabel(rawII);
		masin = new JLabel(masinII);

		westAxisII = new ImageIcon("./gif/west.png");
		westAxisII.setImage(westAxisII.getImage().getScaledInstance(25, scale/2, Image.SCALE_FAST));
		southAxisII = new ImageIcon("./gif/south.png");
		southAxisII.setImage(southAxisII.getImage().getScaledInstance(scale+25, 25, Image.SCALE_FAST));
		wwestAxisII = new ImageIcon("./gif/west.png");
		wwestAxisII.setImage(wwestAxisII.getImage().getScaledInstance(25, scale/2, Image.SCALE_FAST));
		ssouthAxisII = new ImageIcon("./gif/south.png");
		ssouthAxisII.setImage(ssouthAxisII.getImage().getScaledInstance(scale+25, 25, Image.SCALE_FAST));

		westAxis = new JLabel(westAxisII);
		wwestAxis = new JLabel(wwestAxisII);
		southAxis = new JLabel(southAxisII);
		ssouthAxis = new JLabel(ssouthAxisII);

		// put together the gui
/*		// consists of one main border layout containing 2 borderlayouts side-by-side
		JLabel top = new JLabel("CORHEL 2.0",JLabel.CENTER);
		add(top,BorderLayout.NORTH);
*/
		BorderLayout ppbl = new BorderLayout();
		JPanel preprocess = new JPanel(new BorderLayout());
		JLabel pptop = new JLabel("Select and Preview Input",JLabel.CENTER);
		preprocess.add(pptop,BorderLayout.NORTH);

		JPanel runcorhel = new JPanel(new BorderLayout());
		JLabel rctop = new JLabel("Run Corhel",JLabel.CENTER);

		// each sub-borderlayout has 2 grid layouts 

		JPanel ppbutnP  = new JPanel(new GridLayout(7,2));
		JPanel pppicP  = new JPanel(new GridLayout(1,2)) ;
		JPanel rawPicP  = new JPanel(new BorderLayout());
		JPanel masinPicP  = new JPanel(new BorderLayout());
		JPanel rcbutnP  = new JPanel(new GridLayout(7,2));
		JPanel rcpicP  = new JPanel(new GridLayout(2,2));
		JPanel picLabP  = new JPanel(new GridLayout(1,2));
		JPanel botm  = new JPanel(new GridLayout(1,2));
		JPanel xtra = new JPanel(new BorderLayout());
		JPanel bigpan = new JPanel(new BorderLayout());

		JLabel scaleMinLabel = new JLabel("Image Scale Min");
		JLabel scaleMaxLabel = new JLabel("Image Scale Max");

		// add the picture labels on the far west
		preprocess.add(picLabP,BorderLayout.WEST);
		// add the pictures to the east 
		rawPicP.add(raw,BorderLayout.CENTER);
		rawPicP.add(westAxis,BorderLayout.WEST);
		rawPicP.add(southAxis,BorderLayout.SOUTH);
		pppicP.add(rawPicP);
		masinPicP.add(masin,BorderLayout.CENTER);
		masinPicP.add(wwestAxis,BorderLayout.WEST);
		masinPicP.add(ssouthAxis,BorderLayout.SOUTH);
		pppicP.add(masinPicP);

		((GridLayout)(pppicP.getLayout())).setHgap(10);
		// separate panel
		picLabP.add(rawLabel);
		picLabP.add(masinLabel);
		xtra.add(picLabP,BorderLayout.SOUTH);
		xtra.add(pppicP,BorderLayout.CENTER);
		preprocess.add(xtra,BorderLayout.CENTER);
		// buttons
		ppbutnP.add(new JLabel());
		ppbutnP.add(new JLabel());
		ppbutnP.add(obsLabel);
		ppbutnP.add(obsBox);
		ppbutnP.add(crBoxLabel);
		ppbutnP.add(crBox);
		ppbutnP.add(resBoxLabel);
		ppbutnP.add(resBox);
		ppbutnP.add(palBoxLabel);
		ppbutnP.add(palBox);
		ppbutnP.add(resetButton);
		ppbutnP.add(helpButton);
		ppbutnP.add(processButton);
		ppbutnP.add(quitButton);

		((GridLayout)(ppbutnP.getLayout())).setVgap(10);

		botm.add(ppbutnP);

		// buttons

		rcbutnP.add(new JLabel());
		rcbutnP.add(new JLabel());
		rcbutnP.add(scaleMinLabel);
		rcbutnP.add(scaleMinBox);
		rcbutnP.add(scaleMaxLabel);
		rcbutnP.add(scaleMaxBox);
		rcbutnP.add(mmmaxLabel);
		rcbutnP.add(mmmaxBox);
		rcbutnP.add(ebMinLabel);
		rcbutnP.add(ebMinBox);
		rcbutnP.add(ebMaxLabel);
		rcbutnP.add(ebMaxBox);
		rcbutnP.add(ePointLabel);
		rcbutnP.add(ePointBox);
	//	rcbutnP.add(proBarLabel);
	//	rcbutnP.add(proBar);
		((GridLayout)(rcbutnP.getLayout())).setVgap(10);

		botm.add(rcbutnP);
		((GridLayout)(botm.getLayout())).setHgap(10);

		// the big panel
		bigpan.add(botm,BorderLayout.SOUTH);
		// add the sublayouts
		bigpan.add(preprocess,BorderLayout.WEST);
		bigpan.add(runcorhel,BorderLayout.EAST);

		add(bigpan,BorderLayout.NORTH);

		JPanel stepTwo = new JPanel(new GridLayout(2,1,5,5));
		//stepTwo.add(new JLabel());
		//stepTwo.add(new JLabel());
		//stepTwo.add(new JLabel());
		stepTwo.add(new JSeparator());
		JPanel buttons = new JPanel(new GridLayout(1,3,5,5));

		//buttons.add(new JLabel());
		//stepTwo.add(bcs);
		//buttons.add(new JLabel());
		//buttons.add(new JLabel());

		buttons.add(bcs);
		buttons.add(helio);
/*		stepTwo.add(new JLabel());
		stepTwo.add(new JLabel());
		stepTwo.add(new JLabel());
		stepTwo.add(new JLabel());
		stepTwo.add(new JLabel());
*/
		//stepTwo.add(crhlLabel);
/*		stepTwo.add(new JLabel());
		stepTwo.add(new JLabel());
*/
		buttons.add(crhl);
		//stepTwo.add(new JLabel());
		stepTwo.add(buttons);


		//((GridLayout)(stepTwo.getLayout())).setVgap(10);
		//((GridLayout)(buttons.getLayout())).setVgap(10);

		add(stepTwo,BorderLayout.CENTER);

		// this goes into next page
//		ppbutnP.add(resBoxLabel);
//		ppbutnP.add(resBox);

	}

	public static void pt(String s) {System.out.println(s); }
	public static void pt(int s) {System.out.println(s); }
	public static void pt(int[] s) { for (int i=0; i< s.length; i++) {System.out.println(s[i]);} }
	

	public Image rotate(Image InImg, int x, int y) {
		Image OutImg = null;
		
		int size = x * y;
		int buffer[] = new int[size];
		int rotate[] = new int[size];
		int bufferIndex[] = new int[size];
		int rotateIndex[] = new int[size];
	
		PixelGrabber grabber = new PixelGrabber(InImg,0,0,x,y,buffer,0,x);
		try {
			grabber.grabPixels();
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}
		int b,r,i;
		for (i = 0; i < bufferIndex.length; i++) {
			bufferIndex[i] = i;
		}

		rotateIndex[size-1] = bufferIndex[x-1];
		for (i = size - 2; i > (size-y-1); i--){
			rotateIndex[i] = rotateIndex[i+1] + x;
		}

		for (i = size-1-y; i >= 0; i--) {
				rotateIndex[i] = rotateIndex[i+y]-1;
		}
		for (i = 0; i < size; i++) {
			rotate[i] = buffer[rotateIndex[i]];
		}
		
		OutImg = createImage(new MemoryImageSource(y,x,rotate,0,y));
		//OutImg = createImage(new MemoryImageSource(x,y,buffer,0,x));
		

		if (false) {
			pt("bufferIndex");
			pt(bufferIndex);
			pt("rotateIndex");
			pt(rotateIndex);
			pt("buffer");
			pt(buffer);
			pt("rotate");
			pt(rotate);
		}

		return OutImg;
	//	return InImg;
	}

	public void actionPerformed(ActionEvent e){
		//Error Checking goes here for cr, scale min/max, and epoints
		//crBox Rules: 1625 <= cr <= 2007 or >2010 
		try {   
            Double.parseDouble(crBox.getText());
        }       
        catch (NumberFormatException exc) {
            //Reset offending input to its default
			crBox.setText("1913");
		}
		if (Float.parseFloat(crBox.getText()) > 2007 && Float.parseFloat(crBox.getText()) <= 2010 && obsBox.getSelectedIndex() == 0 ) crBox.setText("2007");
		if (Float.parseFloat(crBox.getText()) < 1625) crBox.setText("1625");

		//Scale MIN/MAX Rules Max > Min
		float smin, smax;
		try {
			smin = Float.parseFloat(scaleMinBox.getText());
		}    
        catch (NumberFormatException exc) {
            //Reset offending input to its default
            scaleMinBox.setText("-40");
			smin = -40;
        }	
		try {
			smax = Float.parseFloat(scaleMaxBox.getText());
		}
        catch (NumberFormatException exc) {
            //Reset offending input to its default
            scaleMaxBox.setText("40");
            smax = 40;
        }
 		if (smin > smax) scaleMinBox.setText(Float.toString(smax));  

		//Extrapolation Point Rules: Min <= epoint <= Max && All betwen 0 -> 1.57
		float emin, emax, epoint;
		try {
			emin = Float.parseFloat(ebMinBox.getText());
		}
        catch (NumberFormatException exc) {
            //Reset offending input to its default
            ebMinBox.setText("0.25");
            emin = Float.parseFloat(ebMinBox.getText());
        }
		try {
			emax = Float.parseFloat(ebMaxBox.getText());
        }
        catch (NumberFormatException exc) {
            //Reset offending input to its default
            ebMaxBox.setText("0.45");
            emax = Float.parseFloat(ebMaxBox.getText());;
        }
		try {
			epoint = Float.parseFloat(ePointBox.getText());
        }
        catch (NumberFormatException exc) {
            //Reset offending input to its default
            ePointBox.setText("0.35");
            epoint = Float.parseFloat(ePointBox.getText());
        }
		if (emin < 0 ) ebMinBox.setText("0");
		if (emin > 1.57) ebMinBox.setText("1.57");
		if (emax < 0) ebMaxBox.setText("0");
		if (emax > 1.57) ebMaxBox.setText("1.57");
		//Reread ebMin and ebMax in case they were changed
		emin = Float.parseFloat(ebMinBox.getText());
		emax = Float.parseFloat(ebMaxBox.getText());
		if (epoint < emin) ePointBox.setText(Float.toString(emin));
		if (epoint > emax) ePointBox.setText(Float.toString(emax));

        if ("process".equals(e.getActionCommand())) {
			try {
				takeInput(crBox.getText(),
						resNum[resBox.getSelectedIndex()],
						palettes[palBox.getSelectedIndex()],
						mmmaxNum[mmmaxBox.getSelectedIndex()], 
						ebMinBox.getText(),
						ebMaxBox.getText(),
						ePointBox.getText(),
						scaleMinBox.getText(), 
						scaleMaxBox.getText(),
						observatory[obsBox.getSelectedIndex()].toLowerCase());
				go();
			}
			catch (java.io.IOException ioe) {
				System.err.println(ioe.getMessage());
			}
			catch (InterruptedException ie) {
				System.err.println(ie.getMessage());
			}
		}
        if ("corhel".equals(e.getActionCommand())) {
/*			Object[] options = {"low","medium"};
			JOptionPane.showOptionDialog(null,"select resolution","CORHEL Options",
					JOptionPane.DEFAULT_OPTION,JOptionPane.PLAIN_MESSAGE,null,options,options[0]);
*/
			//Run the coronal-heliospheric model
			createIMAS(mmmaxBox.getSelectedIndex());
			runCorhel();
		}
		if ("helio".equals(e.getActionCommand())) {
			//try {
/*				heliotakeInput(crBox.getText(),
						resNum[resBox.getSelectedIndex()],
						palettes[palBox.getSelectedIndex()],
						mmmaxNum[mmmaxBox.getSelectedIndex()], 
						ebMinBox.getText(),
                        ebMaxBox.getText(),
                        ePointBox.getText(),
						scaleMinBox.getText(), 
						scaleMaxBox.getText(),
						true);

				go();
*/
				//New Helio Options go here
				//Temporarily pop up a message window saying there are no Helio Options
				if (helioFrame == null) System.out.println("DOH");
				helioFrame.setVisible(true);
			//}
			//catch (java.io.IOException ioe) {
			//	System.err.println(ioe.getMessage());
			//}
			//catch (InterruptedException ie) {
			//	System.err.println(ie.getMessage());
			//}
		}
		if ("corona".equals(e.getActionCommand())) {
            //try {
				//Coronal Input File Options are drawn here
                coronaFrame.setVisible(true);
            //}
            //catch (java.io.IOException ioe) {
            //    System.err.println(ioe.getMessage());
            //}
            //catch (InterruptedException ie) {
            //    System.err.println(ie.getMessage());
            //}
        }
		if ("help".equals(e.getActionCommand())) {
			((helpMenu) helpWindow).getHelp(helpMenu.MAIN);
		}
		if ("quit".equals(e.getActionCommand())) {
			System.exit(0);
		}
		if ("reset".equals(e.getActionCommand())) {
			//Reset Inputs to default
			obsBox.setSelectedIndex(0);
			crBox.setText("1913");
			resBox.setSelectedIndex(0);
			palBox.setSelectedIndex(9);
			scaleMinBox.setText("-40.0");
			scaleMaxBox.setText("40.0");
			mmmaxBox.setSelectedIndex(9);
			ebMinBox.setText("0.25");
			ebMaxBox.setText("0.45");
			ePointBox.setText("0.35");
			((coronalOptions) coronalOps).reset();
			((helioOptions) helioOps).reset();

			actionPerformed(new ActionEvent(processButton,ActionEvent.ACTION_PERFORMED, "process"));
		}

	}

/*	public void heliotakeInput(String cr, 
						String res, 
						String pal, 
						String mmmax, 
						String ebmin, 
						String ebmax, 
						String epoint, 
						String scaleMin, 
						String scaleMax) throws java.io.IOException, InterruptedException {
		CR = Integer.parseInt(cr);
		RES = res;
		File f;
		String tmp;
		Process p;
		Runtime run = Runtime.getRuntime();			
	
		String cmd;
		BufferedReader br;

		// run helio
	
		cmd = root_path + "/bin/corhel_helio "+ cr+" "+res ;
		System.out.println(cmd);
		p = run.exec(cmd);
		br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		
		tmp =br.readLine();
		while (tmp != null) {
			System.out.println(tmp);
			tmp = br.readLine();
		}
		p.waitFor();
		p.destroy();
		
	}
*/	

	public void takeInput(String cr, 
						String res, 
						String pal, 
						String mmmax, 
						String ebmin, 
						String ebmax, 
						String epoint, 
						String scaleMin, 
						String scaleMax,
						String observ) throws java.io.IOException, InterruptedException {
		CR = Integer.parseInt(cr);
		RES = res;
		File f;
		String tmp;
		Process p;
		Runtime run = Runtime.getRuntime();			
		String cmd;

		if (observ.equals("kittpeak/solis")) observ = "kittpeak";

		cmd = root_path + "/gui/CLEAR";
		System.out.println(cmd);
		p = run.exec(cmd);
		p.waitFor();
		p.destroy();
		

		BufferedReader br;
		// run corhel
	
		cmd = root_path + "/bin/corhel "+ cr+" "+res ;
		System.out.println(cmd);
		p = run.exec(cmd);
		br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		
		tmp =br.readLine();
		while (tmp != null) {
			System.out.println(tmp);
			tmp = br.readLine();
		}
		p.waitFor();
		p.destroy();
	

		// run corona
	
		cmd = root_path + "/bin/prep_corona "+ cr+" "+res+" "+ mmmax +" "+ ebmin+" "+ ebmax+" "+ epoint + " " + observ;
		System.out.println(cmd);
		p = run.exec(cmd);
		br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		
		tmp =br.readLine();
		while (tmp != null) {
			System.out.println(tmp);
			tmp = br.readLine();
		}
		p.waitFor();
		p.destroy();
	

		double rmin = Double.parseDouble(scaleMin) * 2.2;
		double rmax = Double.parseDouble(scaleMax) * 2.2;

//		cmd = root_path + "/corhel "+ cr+" "+res ;
		cmd = root_path + "/gui/HDF2GIF"+" "+ cr+" "+ res+" "+ pal+" "+scaleMin+" "+scaleMax+" "+rmin+" "+rmax;;
		System.out.println(cmd);
		p = run.exec(cmd);
		br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		
		tmp =br.readLine();
        while (tmp != null) {
            System.out.println(tmp);
            tmp = br.readLine();
        }
		p.waitFor();
        p.destroy();
/*
		CR = Integer.parseInt(cr);
		RES = res;
		String cmd = "/bin/sh /Users/janvier/OSXCORHEL2/gui/PRO " + cr + " " +  res + " " + mmmax + " " + ebmin + " " + ebmax  + " " + epoint + " " +  pal  + " " +  scaleMin  + " " +  scaleMax ;
		Process p = (Runtime.getRuntime()).exec(cmd,new String[] {""}, new File("./"));
		BufferedReader br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		while (br.readLine() != null) {
			System.out.println(br.readLine());
		}
		Process p = (Runtime.getRuntime()).exec("CLEAR",new String[] {""}, new File("../"));
		try {
			p.waitFor();
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}

		String cmd = "CORHEL2 " + cr + " " +  res + " " + mmmax + " " + ebmin + " " + ebmax  + " " + epoint;
		p = (Runtime.getRuntime()).exec(cmd,new String[] {""}, new File("../"));
		BufferedReader br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		
		while (br.readLine() != null) {
			System.out.println(br.readLine());
		}
		try {
			p.waitFor();
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}
		cmd = "HDF2GIF " +  cr  + " " +  res  + " " +  pal  + " " +  scaleMin  + " " +  scaleMax;
		p = (Runtime.getRuntime()).exec(cmd,new String[] {""}, new File("../"));
		br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		
		int i=0;
		while (br.readLine() != null) {
			System.out.println(br.readLine());
			System.out.println(i++);
		}
		System.out.println(i);

		try {
			p.waitFor();
		}
		catch(InterruptedException e) {
			e.printStackTrace();
		}
*/

		
	}

	public void createIMAS(int modenum) {
		//Create and write imas file for run
		String modestring = new String("0");
		for (int i = 1; i <= modenum; i++) {
			modestring += "," + i;
		}

		coronalOptions tmp = (coronalOptions) coronalOps;
		
		String imas = " &invars\n" 
					+ " option='streamer'\n"
					+ " fldtype='potential' bingauss=.true. bnfile='br.m9.filt3.dat'\n"
					+ " eqtype='parker' np1d=130 onedfile='parker1.8.pw' rhor0=2.\n"
					+ " bcr0type='1dchar' bcr1type='1dchar'\n"
					+ " tmax=" + tmp.getMaxTime() + " ntmax=40000" 
					+ " dtmax=" + tmp.getDtMax() + " dtmin=" +tmp.getDtMin() + "\n"
					+ " ifideal=0 slund=" + tmp.getLundNum() + " visc=" + tmp.getViscosity() + "\n"
					+ " rsifile=' '\n"
					+ " rl=" + tmp.getOuterRadial() + ". g0=.823 ifrho=1 iftemp=1 ifvdgv=1 ifpc=1\n"
					+ " rfrac=.4,1. drratio=60.,4. nfrmesh=5\n"
					+ " tfrac=.5,1. dtratio=.5,2. nftmesh=5\n"
					+ " mmodes=" + modestring + "\n"
					+ " tpltxint=" + tmp.getOutputInt() + ". ihistint=1 ifprec=1 trsdump=20.\n"
					+ " upwindv=1. cfl=.4 isitype=1\n"
					+ " dformat='hdf'\n"
					+ " plotlist=" + tmp.getOutputParams() + "\n"
					+ " tnode=0.,10.0 vnode=0.,0. ishearprof=2\n"
					+ " arotate=1. brotate=0. crotate=0.\n"
					+ " ihst=23 jhst=33 khst=1\n"
					+ " parchar=.false. ubzero=.true. nfiltub=3\n"
					+ " he_frac=0. radloss=0. tcond=0. ifaw=0\n"
					+ " tnode_ch=0.,500. q0phys_ch=0.,0.\n"
					+ " tbc0=1.8e6 tbc1=0.\n"
					+ " upwinda=0. upwindar=1. upwindat=1. upwindap=1.\n"
					+ " upwindphi=1. strmax=.4\n"
					+ " fdphi=.false.\n"
					+ " si_aggressive=.true.\n"
					+ " /";
		//Write imas file
		System.out.println("MAS Input File:\n");
		System.out.println(imas);

		try {
			FileWriter fw = new FileWriter(root_path + "/run/cr" + crBox.getText() + "-"
				+ resNum[resBox.getSelectedIndex()] + "/corona/imas");
			fw.write(imas);
			fw.flush();
			fw.close();
		}
		catch (IOException e) {
            System.out.println("There was an I/O Exception\nShutting Down");
            System.exit(1);
        }
	}

	public void runCorhel() {
		//Run CORHEL (corhel_run)
        Process p;
        Runtime run = Runtime.getRuntime();
        String cmd, tmp;
		BufferedReader br;

		try {
			cmd = root_path + "/bin/corona "+ crBox.getText() + " " + resNum[resBox.getSelectedIndex()];
			System.out.println(cmd);
			p = run.exec(cmd);
			br = new BufferedReader(new InputStreamReader(p.getInputStream()));

			tmp =br.readLine();
			while (tmp != null) {
			    System.out.println(tmp);
				tmp = br.readLine();
			}
			p.waitFor();
			p.destroy();
		}
		catch (IOException e) {
			System.out.println("There was an I/O Exception\nShutting Down");
			System.exit(1);
		}
		catch (InterruptedException e) {
			System.out.println("There was an Interrupted Exception\nShutting Down");
            System.exit(1);
		}
	}
	
    public static void main(String[] args) {
	if (args[0] == null) {
	    System.out.println("The Corhel Root path must be passed as an argument");
	    System.exit(1);
	}
	final String arg = args[0];
	javax.swing.SwingUtilities.invokeLater(
	new Runnable() {
	    public void run() {
	    createAndShowGUI(arg);
	    }
	});
    }
}
