//helpMenu.java
//Help Menu Class

//Import Statements
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;


public class helpMenu extends JPanel {
	private JTabbedPane helpPane;
	private JEditorPane mainHelp, coronaHelp, helioHelp;
	private JFrame myframe;
	private String rootpath;

	public static final int MAIN = 0;
	public static final int CORONA = 1;
	public static final int HELIO = 2;

	public helpMenu(JFrame frm, String rute) {
		//Constructor for helpMenu Window
		super(new GridLayout(1,1));

		//Set My Frame
		myframe = frm;
		rootpath = rute;

		//Initialize Tabbed Pane
		helpPane = new JTabbedPane();

		//Initialize the Help Text Panes
		try {
			mainHelp = new JEditorPane("file://" + rootpath + "/gui/help/main.txt");
			coronaHelp = new JEditorPane("file://" + rootpath + "/gui/help/corona.txt");
			helioHelp = new JEditorPane("file://" + rootpath + "/gui/help/helio.txt");
		}
		catch (IOException e) {
			System.out.println("Error: " + e.getMessage());
			System.exit(1);
		}

		//Make the Editor Panes Uneditable
		mainHelp.setEditable(false);
		coronaHelp.setEditable(false);
		helioHelp.setEditable(false);

		mainHelp.setContentType("text/plain");
        coronaHelp.setContentType("text/plain");
        helioHelp.setContentType("text/plain");

		//Add text panes to tabbed pane
		helpPane.add("Main Window", mainHelp);
		helpPane.add("Coronal Options", coronaHelp);
		helpPane.add("Heliospheric Options", helioHelp);

		//Set Preferred Size of Help Pane
		helpPane.setPreferredSize(new Dimension(400,400));

		//Add the Help Pane to Main JPanel
		add(helpPane);
	}

	public void getHelp(int tab) {
		//Select Which tab to show
		helpPane.setSelectedIndex(tab);

		//Set Frame visible
		myframe.setVisible(true);
	}

};
