!****h* e0pro/main
! NAME 
!   COMDIM
! PURPOSE
!   Array dimensions
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMDIM
!---------------------------------------------------------------------
  USE commax        !Get maximum array dimensions
  IMPLICIT NONE
  PUBLIC
!L--------------------------------------------------------------------
!L                  A.2      Dimensionality parameters
#ifdef x2dim
  INTEGER, PARAMETER :: n2d=1
#else
  INTEGER, PARAMETER :: n2d=0
#endif
#ifdef x3dim
  INTEGER, PARAMETER :: n3d=1
#else
  INTEGER, PARAMETER :: n3d=0
#endif
!L--------------------------------------------------------------------
!L                  A.3      Number of main variables
#ifdef mhd
#ifdef mhdcon
#ifdef hydcon
  INTEGER, PARAMETER :: nnvar=10, npvar=6
#else
  INTEGER, PARAMETER :: nnvar=9, npvar=6
#endif
#else
#ifdef hydcon
  INTEGER, PARAMETER :: nnvar=9, npvar=6
#else
  INTEGER, PARAMETER :: nnvar=8, npvar=6
#endif
#endif
#else
#ifdef hydcon
  INTEGER, PARAMETER :: nnvar=6, npvar=4
#else
  INTEGER, PARAMETER :: nnvar=5, npvar=4
#endif
#endif
!L--------------------------------------------------------------------
!L                  A.4      Auxiliary values
  INTEGER, PARAMETER :: ng1=ngguard, ng2=ngguard*n2d, ng3=ngguard*n3d
  INTEGER, PARAMETER :: nc1=ncc1+2*ngguard
  INTEGER, PARAMETER :: nc2=ncc2+2*ngguard*n2d
  INTEGER, PARAMETER :: nc3=ncc3+2*ngguard*n3d
  INTEGER, PARAMETER :: nc=max(nc1,nc2,nc3)
  INTEGER, PARAMETER :: ncc=max(ncc1,ncc2,ncc3)
  INTEGER, PARAMETER :: nh1=nc1+1, nh2=nc2+1, nh3=nc3+1, nh=nc+1
  INTEGER, PARAMETER :: nhh1=ncc1+1, nhh2=ncc2+1, nhh3=ncc3+1
!L--------------------------------------------------------------------
!L                  A.5      Actual array dimensions
  INTEGER  nb1, nb2, nb3, nhel, nsel, ngeo, npla, nfld, nblk
END MODULE COMDIM
