!****h* e0pro/main
! NAME 
!   COMGLO
! PURPOSE
!   Global variables
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMGLO
!---------------------------------------------------------------------  
  USE comdim        !Get actual array dimensions
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L                  G.1      Auxiliary variables                      
  REAL(kind=8), DIMENSION(nnvar) :: UL,  UR
  REAL(kind=8), DIMENSION(npvar) :: VPL, VPR
#ifndef split
  REAL(kind=8), DIMENSION(nc1,nc2,nc3,nnvar) :: UO, UN, UA
  REAL(kind=8), DIMENSION(nc1,nc2,nc3,npvar) :: VP, VPO
#endif
!---------------------------------------------------------------------  
!L                  G.2      Staggered field variables                      
#ifdef staggered
    REAL(kind=8), DIMENSION(nh1,nc2,nc3) :: B1HCC, E2HCC, E3HCC
    REAL(kind=8), DIMENSION(nc1,nh2,nc3) :: B2CHC, E1CHC, E3CHC
    REAL(kind=8), DIMENSION(nc1,nc2,nh3) :: B3CCH, E1CCH, E2CCH
    REAL(kind=8), DIMENSION(nc1,nh2,nh3) :: E1CHH
    REAL(kind=8), DIMENSION(nh1,nc2,nh3) :: E2HCH
    REAL(kind=8), DIMENSION(nh1,nh2,nc3) :: E3HHC
#else
#ifndef split
#ifdef toth
        REAL(kind=8), DIMENSION(nh1,nc2,nc3) :: E2HCC, E3HCC
        REAL(kind=8), DIMENSION(nc1,nh2,nc3) :: E1CHC, E3CHC
        REAL(kind=8), DIMENSION(nc1,nc2,nh3) :: E1CCH, E2CCH
        REAL(kind=8), DIMENSION(nc1,nh2,nh3) :: E1CHH
        REAL(kind=8), DIMENSION(nh1,nc2,nh3) :: E2HCH
        REAL(kind=8), DIMENSION(nh1,nh2,nc3) :: E3HHC
#endif
#endif
#endif
!---------------------------------------------------------------------  
!L                  G.3      Hydrodynamic variables                      
#ifdef PARAMESH                                                         
#else                                                                   
#ifdef staggered
      REAL(kind=8), DIMENSION(1,nh1,nc2,nc3,maxblk) ::  FACEVARX,   &
                                                        FACEVARY,   &
                                                        FACEVARZ     
#endif                                                                  
    REAL(kind=8), DIMENSION(nnvar,nc1,nc2,nc3,maxblk) ::  UNK 
#endif                                                                  
#ifdef hydcon                                                           
    REAL(kind=8), DIMENSION(nc1,nc2,nc3) ::  D, T, V1, V2, V3, DP
#else                                                                   
    REAL(kind=8), DIMENSION(nc1,nc2,nc3) ::  D, T, V1, V2, V3 
#endif 
#ifdef mhd                                                              
!---------------------------------------------------------------------  
!L                  G.4      Magnetohydrodynamic variables                      
!   REAL(kind=8), DIMENSION(nc1,nc2,nc3) :: A1, A2, A3
    REAL(kind=8), DIMENSION(nc1,nc2,nc3) :: B1, B2, B3 
!   REAL(kind=8), DIMENSION(nc1,nc2,nc3) :: B1A, B2A, B3A 
#ifdef mhdcon                                                           
      REAL(kind=8), DIMENSION(nc1,nc2,nc3) :: BP 
#endif 
#ifdef powell                                                           
!     REAL(kind=8), DIMENSION(nc1,nc2,nc3) ::   DO, UUO, DV1O, DV2O,   &
!                                               DV3O, B1O, B2O, B3O    
#endif                                                                  
#endif
#ifdef difbb                                                         
    REAL(kind=8), DIMENSION(nc1,nc2,nc3,maxblk) ::  PSIO, PSIA, PSIN
#endif
!---------------------------------------------------------------------  
#ifdef toth                                                          
      REAL(kind=8), DIMENSION(3,nc1,nc2,nc3,maxblk) ::  UNKA 
#endif
END MODULE COMGLO
