!****h* e0pro/main
! NAME 
!   COMBND
! PURPOSE
!   Output control parameters and array buffers
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMOUT
!---------------------------------------------------------------------  
  USE commax        !Get maximum array dimensions
  USE comdim        !Get actual array dimensions
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L                  O.1      Output control (physical time)
  REAL(kind=8)  TSFROM, TSTO, TSSTEP, TSOUT, TDFROM, TDTO,            &
                TDSTEP, TDOUT, TEFROM, TETO, TESTEP, TEOUT, TFFROM,   &
                TFTO, TFSTEP, TFOUT, TPFROM, TPTO, TPSTEP, TPOUT,     &
                TTFROM, TTTO, TTSTEP, TTOUT, TVFROM, TVTO, TVSTEP,    &
                TVOUT, X1S, X2S, X3S
!---------------------------------------------------------------------  
!L                  O.2      Output control (computational step number)
  INTEGER  NSFROM, NSTO, NSSTEP, NSOUT, NDFROM, NDTO, NDSTEP, NDOUT,  &
           NEFROM, NETO, NESTEP, NEOUT, NFFROM, NFTO, NFSTEP, NFOUT,  &
           NPFROM, NPTO, NPSTEP, NPOUT, NTFROM, NTTO, NTSTEP, NTOUT,  &
           NVFROM, NVTO, NVSTEP, NVOUT, NX1S, NX2S, NX3S, NVRED
!---------------------------------------------------------------------  
!L                  O.3      Output buffers
  REAL(kind=8)  ZH1, ZH2, ZH3, ZX1, ZX2, ZX3, ZX123, ZZH1, ZZH2, ZZH3,&
                ZZX1, ZZX2, ZZX3, ZZX123, ZZGAM,                      &
#ifdef staggered                                                        
                ZXH23, ZX1H3, ZX12H, ZZXH23, ZZX1H3, ZZX12H,          &
#endif 
             ZZX12, ZZX13, ZZX23, ZX1S, ZX2S, ZX3S, ZHEL, ZVAR         
  DIMENSION  ZH1(nhh1,maxblk), ZH2(nhh2,maxblk),                    &
             ZH3(nhh3,maxblk),  ZX1(ncc1,maxblk),                   & 
             ZX2(ncc2,maxblk),     ZX3(ncc3,maxblk),                & 
             ZX123(ncc1,ncc2, ncc3,maxblk),   ZZH1(ncc1+1),         &
             ZZH2(ncc2+1), ZZH3(ncc3+1), ZZX1(ncc1), ZZX2(ncc2),    &
             ZZX3(ncc3), ZZX123(ncc1,ncc2,ncc3),                    &
             ZZGAM(ncc1,ncc2),                                      &
#ifdef staggered                                                      
             ZXH23(nhh1,ncc2,ncc3,maxblk),                         &
             ZX1H3(ncc1,nhh2,ncc3,maxblk),                         &
             ZX12H(ncc1,ncc2,nhh3,maxblk),                         &
             ZZXH23(nhh1,ncc2,ncc3), ZZX1H3(ncc1,nhh2,ncc3),       &
             ZZX12H(ncc1,ncc2,nhh3),                               &
#endif                                                                  
             ZZX12(ncc1,ncc2), ZZX13(ncc1,ncc3), ZZX23(ncc2,ncc3), &
             ZHEL(maxhel)
!---------------------------------------------------------------------  
!L                  O.4      Output buffers
  REAL(kind=4)  Z4H1, Z4H2, Z4H3, Z4X1, Z4X2, Z4X3, Z4X123, Z4VAR 
  DIMENSION  Z4H1(ncc1+1,maxblk), Z4H2(ncc2+1,maxblk),              &
             Z4H3(ncc3+1,maxblk), Z4X1(ncc1,maxblk),                &
             Z4X2(ncc2,maxblk),                                     &
             Z4X3(ncc3,maxblk), Z4X123(ncc1,ncc2,ncc3,maxblk)          
!---------------------------------------------------------------------  
!L                  O.1      Output buffers
  REAL(kind=8)  Z8H1, Z8H2, Z8H3, Z8X1, Z8X2, Z8X3, Z8X123, Z8VAR 
  DIMENSION  Z8H1(ncc1+1), Z8H2(ncc2+1), Z8H3(ncc3+1),                &
             Z8X1(ncc1), Z8X2(ncc2), Z8X3(ncc3), Z8X123(ncc1,ncc2,ncc3)  
!---------------------------------------------------------------------  
!L                  O.1      Output buffers
  REAL(kind=8), DIMENSION(ncc1,ncc2,ncc3) ::  ZBUF
END MODULE COMOUT
