!****m* e0pro/main
! NAME 
!   COMPRO
! PURPOSE
!   Program labels
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMPRO
!---------------------------------------------------------------------  
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L                  L.0      Program labels                                  
  CHARACTER(len=9), PARAMETER  ::  lvers = '02/SEP/10'
  CHARACTER(len=8), PARAMETER  ::  lprog = 'ENLIL-3M'
!---------------------------------------------------------------------  
!L                  L.1      Physical model                                      
  CHARACTER(len=8)  LMODEL, LHYDCON, LMHDCON, LGAM3D, LRESIS, LHEAT
#ifdef con                                                              
    PARAMETER (lmodel = 'con     ') 
#endif                                                                  
#ifdef hyd
    PARAMETER (lmodel = 'hyd     ') 
#endif
#ifdef mhd
    PARAMETER (lmodel = 'mhd     ') 
#endif
#ifdef hydcon
    PARAMETER (lhydcon= 'yes     ') 
#else
    PARAMETER (lhydcon= 'no      ') 
#endif
#ifdef mhdcon
    PARAMETER (lmhdcon= 'yes     ') 
#else
    PARAMETER (lmhdcon= 'no      ') 
#endif
#ifdef resis                                                            
    PARAMETER (lresis = 'yes     ') 
#else                                                                   
    PARAMETER (lresis = 'no      ') 
#endif                                                                  
#ifdef heat                                                             
    PARAMETER (lheat = 'yes     ') 
#else                                                                   
    PARAMETER (lheat = 'no      ') 
#endif                                                                  
#ifdef lgam3d                                                           
    PARAMETER (lgam3d = 'yes     ') 
#else                                                                   
    PARAMETER (lgam3d = 'no      ') 
#endif                                                                  
!L                  L.2      Mathematical model                         
  CHARACTER(len=8)  LENERG, LMOMEN, LBDIV
#ifdef etot                                                             
    PARAMETER (lenerg = 'etot    ') 
#endif                                                                  
#ifdef etotmom                                                          
    PARAMETER (lenerg = 'etotmom ') 
#endif                                                                  
#ifdef ethe                                                             
    PARAMETER (lenerg = 'ethe    ') 
#endif                                                                  
#ifdef ediv                                                             
    PARAMETER (lmomen = 'ediv    ') 
#endif                                                                  
#ifdef egrd                                                             
    PARAMETER (lmomen = 'egrd    ') 
#endif                                                                  
#ifdef bdiv                                                             
    PARAMETER (lbdiv = 'bdiv    ') 
#endif                                                                  
#ifdef bgrd                                                             
    PARAMETER (lbdiv = 'bgrd    ') 
#endif                                                                  
!L                  L.3      Computational geometry                                   
  CHARACTER(len=12)  LGEOM
#ifdef cartesian                                                        
    PARAMETER (lgeom = 'cartesian') 
#endif                                                                  
#ifdef cylindrical                                                      
    PARAMETER (lgeom = 'cylindrical') 
#endif                                                                  
#ifdef spherical                                                        
    PARAMETER (lgeom = 'spherical') 
#endif                                                                  
!L                  L.4      Time-dependent boundary conditions         
  CHARACTER(len=8)  LBCTIM
#ifdef bctim1h                                              
    PARAMETER (lbctim= 'bctim1h') 
#endif                                                                  
#ifdef bctim1c                                              
    PARAMETER (lbctim= 'bctim1c') 
#endif                                                                  
#ifdef bctim2c                                              
    PARAMETER (lbctim= 'bctim2c') 
#endif                                                                  
!L                  L.5      Boundary-1                                 
  CHARACTER(len=8)  LBC1L, LBC1R
#ifdef bc1l_constant                                                    
    PARAMETER (lbc1l = 'constant') 
#endif                                                                  
#ifdef bc1l_specified                                                   
    PARAMETER (lbc1l = 'values  ') 
#endif                                                                  
#ifdef bc1l_free                                                        
    PARAMETER (lbc1l = 'free    ') 
#endif                                                                  
#ifdef bc1l_flow                                                        
    PARAMETER (lbc1l = 'flow    ') 
#endif                                                                  
#ifdef bc1l_solid                                                       
    PARAMETER (lbc1l = 'solid   ') 
#endif                                                                  
#ifdef bc1l_periodic                                                    
    PARAMETER (lbc1l = 'periodic') 
#endif                                                                  
#ifdef bc1l_aperiodic                                                   
    PARAMETER (lbc1l = 'aperiodi') 
#endif                                                                  
#ifdef bc1r_constant                                                    
    PARAMETER (lbc1r = 'constant') 
#endif                                                                  
#ifdef bc1r_free                                                        
    PARAMETER (lbc1r = 'free    ') 
#endif                                                                  
#ifdef bc1r_flow                                                        
    PARAMETER (lbc1r = 'flow    ') 
#endif                                                                  
#ifdef bc1r_solid                                                       
    PARAMETER (lbc1r = 'solid   ') 
#endif                                                                  
#ifdef bc1r_periodic                                                    
    PARAMETER (lbc1r = 'periodic') 
#endif                                                                  
#ifdef bc1r_aperiodic                                                   
    PARAMETER (lbc1r = 'aperiodi') 
#endif                                                                  
!L                  L.6      Boundary-2                                 
  CHARACTER(len=8)  LBC2L, LBC2R
#ifdef bc2l_constant                                                    
    PARAMETER (lbc2l = 'constant') 
#endif                                                                  
#ifdef bc2l_free                                                        
    PARAMETER (lbc2l = 'free    ') 
#endif                                                                  
#ifdef bc2l_free0                                                       
    PARAMETER (lbc2l = 'free0   ') 
#endif                                                                  
#ifdef bc2l_flow                                                        
    PARAMETER (lbc2l = 'flow    ') 
#endif                                                                  
#ifdef bc2l_solid                                                       
    PARAMETER (lbc2l = 'solid   ') 
#endif                                                                  
#ifdef bc2l_periodic                                                    
    PARAMETER (lbc2l = 'periodic') 
#endif                                                                  
#ifdef bc2l_aperiodic                                                   
    PARAMETER (lbc2l = 'aperiodi') 
#endif                                                                  
#ifdef bc2r_constant                                                    
    PARAMETER (lbc2r = 'constant') 
#endif                                                                  
#ifdef bc2r_free                                                        
    PARAMETER (lbc2r = 'free    ') 
#endif                                                                  
#ifdef bc2r_free0                                                       
    PARAMETER (lbc2r = 'free0   ') 
#endif                                                                  
#ifdef bc2r_flow                                                        
    PARAMETER (lbc2r = 'flow    ') 
#endif                                                                  
#ifdef bc2r_solid                                                       
    PARAMETER (lbc2r = 'solid   ') 
#endif                                                                  
#ifdef bc2r_periodic                                                    
    PARAMETER (lbc2r = 'periodic') 
#endif                                                                  
#ifdef bc2r_aperiodic                                                   
    PARAMETER (lbc2r = 'aperiodi') 
#endif                                                                  
#ifdef bc2l_none                                                        
    PARAMETER (lbc2l = 'nobc') 
#endif                                                                  
#ifdef bc2r_none                                                        
    PARAMETER (lbc2r = 'nobc') 
#endif                                                                  
!L                  L.7      Boundary-3                                 
  CHARACTER(len=8)  LBC3L, LBC3R
#ifdef bc3l_constant                                                    
   PARAMETER (lbc3l = 'constant') 
#endif                                                                  
#ifdef bc3l_free                                                        
    PARAMETER (lbc3l = 'free    ') 
#endif                                                                  
#ifdef bc3l_flow                                                        
    PARAMETER (lbc3l = 'flow    ') 
#endif                                                                  
#ifdef bc3l_solid                                                       
    PARAMETER (lbc3l = 'solid   ') 
#endif                                                                  
#ifdef bc3l_periodic                                                    
    PARAMETER (lbc3l = 'periodic') 
#endif                                                                  
#ifdef bc3l_aperiodic                                                   
    PARAMETER (lbc3l = 'aperiodi') 
#endif                                                                  
#ifdef bc3r_constant                                                    
    PARAMETER (lbc3r = 'constant') 
#endif                                                                  
#ifdef bc3r_free                                                        
    PARAMETER (lbc3r = 'free    ') 
#endif                                                                  
#ifdef bc3r_flow                                                        
    PARAMETER (lbc3r = 'flow    ') 
#endif                                                                  
#ifdef bc3r_solid                                                       
    PARAMETER (lbc3r = 'solid   ') 
#endif                                                                  
#ifdef bc3r_periodic                                                    
    PARAMETER (lbc3r = 'periodic') 
#endif                                                                  
#ifdef bc3r_aperiodic                                                   
    PARAMETER (lbc3r = 'aperiodi') 
#endif                                                                  
#ifdef bc3l_none                                                        
    PARAMETER (lbc3l = 'nobc') 
#endif                                                                  
#ifdef bc3r_none                                                        
    PARAMETER (lbc3r = 'nobc') 
#endif                                                                  
!L                  L.8      Method of solution                         
  CHARACTER(len=8)  LSCHEM, LUPWIND, LSPLIT, LCFLUX, LIMITR, LVCEN, LVMAX
#ifdef fct                                                              
    PARAMETER (lschem = 'fct     ') 
#endif                                                                  
#ifdef tvd                                                              
    PARAMETER (lschem = 'tvd     ') 
#endif                                                                  
#ifdef upwind                                                           
    PARAMETER (lupwind = 'upwind') 
#else                                                                   
    PARAMETER (lupwind = 'centered') 
#endif                                                                  
#ifdef split                                                            
    PARAMETER (lsplit = 'splitted') 
#else                                                                   
    PARAMETER (lsplit = 'multidim') 
#endif                                                                  
#ifdef cflux                                                            
    PARAMETER (lcflux = 'conser  ') 
#else                                                                   
    PARAMETER (lcflux = 'noconser') 
#endif                                                                  
#ifdef minmod                                                           
    PARAMETER (limitr = 'minmod  ') 
#endif                                                                  
#ifdef roe                                                              
    PARAMETER (limitr = 'roe     ') 
#endif                                                                  
#ifdef woodward                                                         
    PARAMETER (limitr = 'woodward') 
#endif                                                                  
#ifdef vmax                                                             
    PARAMETER (lvcen = 'vcen    ') 
#else                                                                   
    PARAMETER (lvcen = 'novcen  ') 
#endif                                                                  
#ifdef vmax                                                             
    PARAMETER (lvmax = 'vmax    ') 
#else                                                                   
    PARAMETER (lvmax = 'novmax  ') 
#endif                                                                  
!L                  L.9      Div(B) treatment                           
  CHARACTER(len=8)  LPOWEL, LJANHUN, LTOTH, LDIFB, LSTAG           
#ifdef powell                                                           
    PARAMETER (lpowel = 'powell  ') 
#else                                                                   
    PARAMETER (lpowel = 'nopowell') 
#endif                                                                  
#ifdef janhunen                                                 
    PARAMETER (ljanhun= 'janhunen') 
#else                                                                   
    PARAMETER (ljanhun= 'nojanhun') 
#endif                                                                  
#ifdef toth                                                             
    PARAMETER (ltoth = 'toth    ') 
#else                                                                   
    PARAMETER (ltoth = 'nototh  ') 
#endif                                                                  
#ifdef difb                                                             
    PARAMETER (ldifb = 'difb    ') 
#else                                                                   
    PARAMETER (ldifb = 'nodifb  ') 
#endif                                                                  
#ifdef staggered                                                        
    PARAMETER (lstag = 'stag-grd') 
#else                                                                   
    PARAMETER (lstag='cell-cen')
#endif
END MODULE COMPRO
