!****m* e0pro/main
! NAME 
!   COMREG
! PURPOSE
!   Computational region
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMREG
!---------------------------------------------------------------------  
  USE commax, ONLY: maxblk 
  USE comdim, ONLY: nh1, nh2, nh3, nc1, nc2, nc3
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L                  R.1      Topographical X123 parameters              
  REAL(kind=8) ::  X1L, X1R, X2L, X2R, X3L, X3R
  REAL(kind=8) ::  XH1, XH2, XH3, XC1, XC2, XC3 
  DIMENSION  XH1(nh1,maxblk), XH2(nh2,maxblk),                       &
             XH3(nh3,maxblk), XC1(nc1,maxblk),                       &
             XC2(nc2,maxblk), XC3(nc3,maxblk)           
  INTEGER  NC1L, NC1R, NC2L, NC2R, NC3L, NC3R, NC1LM, NC1RP,         &
           NC2LM, NC2RP, NC3LM, NC3RP                                 
END MODULE COMREG                             
