!****m* e0pro/main
! NAME 
!   COMTVA
! PURPOSE
!   Arrays for TVD algorithm
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMTVA
!---------------------------------------------------------------------  
  USE commax        !Get maximum array dimensions
  USE comdim        !Get actual array dimensions
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L                  T.1      Mesh parameters                            
  REAL(kind=8), DIMENSION(nc) :: AX, DX, RAX, RDX, RVOL, VOL, AVLDT, AVRDT
  REAL(kind=8), DIMENSION(nc+1) :: AH, DH, RAH, RDH
  REAL(kind=8), DIMENSION(nc1) :: AX12, AX13, RVOL12, RVOL13, VOL12, VOL13, RRAD
  REAL(kind=8), DIMENSION(nc2) :: RVOL23, VOL23
  REAL(kind=8), DIMENSION(nc1+1) :: AH12, AH13, AHCDT, AHVDT
  REAL(kind=8), DIMENSION(nc1,maxblk) :: AX1, DX1, RAX1, RDX1, RVOL1, VOL1, RX1, RXX1
  REAL(kind=8), DIMENSION(nc2,maxblk) :: AX2, DX2, RAX2, RDX2, COTT, SINT, RSINT
  REAL(kind=8), DIMENSION(nc3,maxblk) :: AX3, DX3, RAX3, RDX3
  REAL(kind=8), DIMENSION(nc1+1,maxblk) :: AH1
  REAL(kind=8), DIMENSION(nc2+1,maxblk) :: AH2
  REAL(kind=8), DIMENSION(nc3+1,maxblk) :: AH3
!L                  T.2      Fluxes                          
  REAL(kind=8), DIMENSION(nc+1) :: DIFH, DIFBH, FLXH
  REAL(kind=8), DIMENSION(nc,nnvar) :: YG, YGG, FLXG
  REAL(kind=8), DIMENSION(nh,nnvar) :: YGH, YGGH
#ifdef mhd                                                              
!L                  T.3      Auxiliary arrays                           
    REAL(kind=8), DIMENSION(nc,nnvar) :: YB, YBA, YBO, YY, YYA, YYO, YYH 
    REAL(kind=8), DIMENSION(nnvar)  ::  YYL, YYR 
#else                                                                   
!L                  T.3      Auxiliary arrays                           
    REAL(kind=8), DIMENSION(nc,nnvar) ::  YY, YYA, YYO, YYH  
    REAL(kind=8), DIMENSION(nnvar)  ::  YYL, YYR 
#endif
END MODULE COMTVA                                                         
