!****f* e0pro/main
! NAME 
!   BND1
! PURPOSE
!   X1-boundary conditions
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
SUBROUTINE BND1 
!---------------------------------------------------------------------
#ifdef PARAMESH                                                         
#include "paramesh_preprocessor.fh"                                     
    use paramesh_dimensions 
    use physicaldata 
    use tree 
#endif                                                                  
  USE comoly 
  USE comdim 
  USE commet
  USE comreg
  USE comglo
  USE combnd
  USE comtva 
  IMPLICIT NONE
  INTEGER j1,j2,j3, i2, i3, iv 
#ifdef DIAGNO                                                           
    call EXPERT(5001,1)
#endif
!---------------------------------------------------------------------
!      1.        X1-left boundary
#ifdef MPI
    if(myproc.eq.0) then
#endif
#ifdef bc1l_specified
#ifdef bctim1h
!        1.1       Specified values (X1-X2-X3 array)
      do j3=1,ncc3
        i3=ng3+j3
        do j2=1,ncc2
          i2=ng2+j2
          unk(1,1,i2,i3,1)=ztwo*dpv(j2,j3)-unk(1,3,i2,i3,1)
          unk(1,2,i2,i3,1)=zthree*dpv(j2,j3)-unk(1,3,i2,i3,1)
          unk(2,1,i2,i3,1)=ztwo*uupv(j2,j3)-unk(2,3,i2,i3,1)
          unk(2,2,i2,i3,1)=zthree*uupv(j2,j3)-unk(2,3,i2,i3,1)
          unk(3,1,i2,i3,1)=ztwo*dv1pv(j2,j3)-unk(3,3,i2,i3,1)
          unk(3,2,i2,i3,1)=zthree*dv1pv(j2,j3)-unk(3,3,i2,i3,1)
          unk(4,1,i2,i3,1)=ztwo*dv2pv(j2,j3)-unk(4,3,i2,i3,1)
          unk(4,2,i2,i3,1)=zthree*dv2pv(j2,j3)-unk(4,3,i2,i3,1)
          unk(5,1,i2,i3,1)=ztwo*dv3pv(j2,j3)-unk(5,3,i2,i3,1)
          unk(5,2,i2,i3,1)=zthree*dv3pv(j2,j3)-unk(5,3,i2,i3,1)
#ifdef mhd
            unk(6,1,i2,i3,1)=ztwo*b1pv(j2,j3)-unk(6,3,i2,i3,1)
            unk(6,2,i2,i3,1)=zthree*b1pv(j2,j3)-unk(6,3,i2,i3,1)
            unk(7,1,i2,i3,1)=ztwo*b2pv(j2,j3)-unk(7,3,i2,i3,1)
            unk(7,2,i2,i3,1)=zthree*b2pv(j2,j3)-unk(7,3,i2,i3,1)
            unk(8,1,i2,i3,1)=ztwo*b3pv(j2,j3)-unk(8,3,i2,i3,1)
            unk(8,2,i2,i3,1)=zthree*b3pv(j2,j3)-unk(8,3,i2,i3,1)
            iv=8
#else
            iv=5
#endif
#ifdef hydcon
            iv=iv+1
            unk(iv,1,i2,i3,1)=ztwo*dppv(j2,j3)-unk(iv,3,i2,i3,1)
            unk(iv,2,i2,i3,1)=zthree*dppv(j2,j3)-unk(iv,3,i2,i3,1)
#endif
#ifdef mhdcon
            iv=iv+1
            unk(iv,1,i2,i3,1)=ztwo*bppv(j2,j3)-unk(iv,3,i2,i3,1)
            unk(iv,2,i2,i3,1)=zthree*bppv(j2,j3)-unk(iv,3,i2,i3,1)
#endif
        enddo
      enddo
#ifdef mhd
#ifdef staggered
          b1hcc(j1,ng2+j2,ng3+j3)=b1pv(j2,j3)
          b2chc(j1,ng2+j2,ng3+j3)=b2pv(j2,j3)
          b3cch(j1,ng2+j2,ng3+j3)=b3pv(j2,j3)
#endif
#endif
#endif
#ifdef bctim1c
!        1.2       Specified values (X1-X2-X3 array)
      do j3=1,ncc3
        i3=ng3+j3
        do j2=1,ncc2
          i2=ng2+j2
          do j1=1,ng1
            unk(1,j1,i2,i3,1)=dpv(j2,j3)
            unk(2,j1,i2,i3,1)=uupv(j2,j3)
            unk(3,j1,i2,i3,1)=dv1pv(j2,j3)
            unk(4,j1,i2,i3,1)=dv2pv(j2,j3)
            unk(5,j1,i2,i3,1)=dv3pv(j2,j3)
#ifdef mhd
              unk(6,j1,i2,i3,1)=b1pv(j2,j3)
              unk(7,j1,i2,i3,1)=b2pv(j2,j3)
              unk(8,j1,i2,i3,1)=b3pv(j2,j3)
              iv=8
#else
              iv=5
#endif
#ifdef hydcon
              iv=iv+1
              unk(iv,j1,i2,i3,1)=dppv(j2,j3)
#endif
#ifdef mhdcon
              iv=iv+1
              unk(iv,j1,i2,i3,1)=bppv(j2,j3)
#endif
          enddo
        enddo
      enddo
#ifdef mhd
#ifdef staggered
          b1hcc(j1,i2,i3)=b1pv(j2,j3)
          b2chc(j1,i2,i3)=b2pv(j2,j3)
          b3cch(j1,i2,i3)=b3pv(j2,j3)
#endif
#endif
#endif
#ifdef bctim2c
!        1.3       Specified values (X1-X2-X3 array)
      do j3=1,ncc3
        i3=ng3+j3
        do j2=1,ncc2
          i2=ng2+j2
          do j1=1,nb1
            unk(1,j1,i2,i3,1)=dpv(j1,j2,j3)
            unk(2,j1,i2,i3,1)=uupv(j1,j2,j3)
            unk(3,j1,i2,i3,1)=dv1pv(j1,j2,j3)
            unk(4,j1,i2,i3,1)=dv2pv(j1,j2,j3)
            unk(5,j1,i2,i3,1)=dv3pv(j1,j2,j3)
#ifdef mhd
              unk(6,j1,i2,i3,1)=b1pv(j1,j2,j3)
              unk(7,j1,i2,i3,1)=b2pv(j1,j2,j3)
              unk(8,j1,i2,i3,1)=b3pv(j1,j2,j3)
              iv=8
#else
              iv=5
#endif
#ifdef hydcon
              iv=iv+1
              unk(iv,j1,i2,i3,1)=dppv(j1,j2,j3)
#endif
#ifdef mhdcon
              iv=iv+1
              unk(iv,j1,i2,i3,1)=bppv(j1,j2,j3)
#endif
          enddo
        enddo
      enddo
#ifdef mhd
#ifdef staggered
          b1hcc(j1,i2,i3)=b1pv(j1,j2,j3)
          b2chc(j1,i2,i3)=b2pv(j1,j2,j3)
          b3cch(j1,i2,i3)=b3pv(j1,j2,j3)
#endif
#endif
#endif
#endif
#ifdef bc1l_free
!        1.4       Free flow (X1-X2-X3 array)
    unk(:,1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,3,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,2,nc2l:nc2r,nc3l:nc3r,:)=unk(:,3,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevary(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarz(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevary(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarz(:,3,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef bc1l_flow
!        1.5       Free flow (X1-X2-X3 array)
    unk(:,1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,4,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,2,nc2l:nc2r,nc3l:nc3r,:)=unk(:,3,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,1,nc2l:nc2r,nc3l:nc3r,:)=                    &
                                   facevarx(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,1,nc2l:nc2r,nc3l:nc3r,:)=                    &
                                   facevary(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,1,nc2l:nc2r,nc3l:nc3r,:)=                    &
                                   facevarz(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,2,nc2l:nc2r,nc3l:nc3r,:)=                    &
                                   facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,2,nc2l:nc2r,nc3l:nc3r,:)=                    &
                                   facevary(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,2,nc2l:nc2r,nc3l:nc3r,:)=                    &
                                    facevarz(:,3,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef bc1l_solid
!        1.6       Solid wall (X1-X2-X3 array)
    unk(:,1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,4,nc2l:nc2r,nc3l:nc3r,:)
    unk(3,1,nc2l:nc2r,nc3l:nc3r,:)=-unk(3,4,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,2,nc2l:nc2r,nc3l:nc3r,:)=unk(:,3,nc2l:nc2r,nc3l:nc3r,:)
    unk(3, 2, nc2l:nc2r, nc3l:nc3r, :)=-unk(3,3,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarx(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevary(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarz(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevary(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                    facevarz(:,3,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef bc1l_periodic
!        1.7       Periodic system (X1-X2-X3 array)
    unk(:,1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,2,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                facevarx(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                facevary(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,1,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                facevarz(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                facevarx(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                facevary(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,2,nc2l:nc2r,nc3l:nc3r,:)=                     &
                                facevarz(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef MPI
    endif
#endif
!---------------------------------------------------------------------
!      2.        X1-right boundary
#ifdef MPI
    if(myproc.eq.nprocs- 1) then
#endif
#ifdef bc1r_free
!        2.1       Free flow (X1-X2-X3 array)
    unk(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevarx(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevary(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevarz(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevarx(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevary(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevarz(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef bc1r_flow
!        2.2       Free flow (X1-X2-X3 array)
    unk(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevarx(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevary(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevarz(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevarx(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevary(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevarz(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef bc1r_solid
!        2.3       Solid wall (X1-X2-X3 array)
    unk(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
    unk(3,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=-unk(3,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
    unk(3,nc1,nc2l:nc2r,nc3l:nc3r,:)=-unk(3,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevarx(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevary(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                facevarz(:,nc1-2,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevarx(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevary(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevary(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
        facevarz(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                facevarz(:,nc1-3,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef bc1r_periodic
!        2.4       Periodic system (X1-X2-X3 array)
    unk(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,3,nc2l:nc2r,nc3l:nc3r,:)
    unk(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=unk(:,4,nc2l:nc2r,nc3l:nc3r,:)
#ifdef mhd
#ifdef staggered
        facevarx(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                    facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                    facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1-1,nc2l:nc2r,nc3l:nc3r,:)=                 &
                                    facevarx(:,3,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                    facevarx(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                    facevarx(:,4,nc2l:nc2r,nc3l:nc3r,:)
        facevarx(:,nc1,nc2l:nc2r,nc3l:nc3r,:)=                   &
                                    facevarx(:,4,nc2l:nc2r,nc3l:nc3r,:)
#endif
#endif
#endif
#ifdef MPI
    endif
#endif
!---------------------------------------------------------------------
!      9.        Return or stop
!correct termination - return
#ifdef DIAGNO
    call EXPERT(5001,0) 
#endif 
RETURN
END SUBROUTINE BND1
