SUBROUTINE INTERP(uold,x2old,x3old,n2old,n3old,unew,x2new,x3new, &
  n2new,n3new,zshift)
!    .   Interpolate boundary values
!  version
  IMPLICIT NONE
  REAL(KIND=8) uold, x2old, x3old, unew, x2new, x3new
  REAL(KIND=8) x2m, x2p, x3m, x3p
  REAL(KIND=8) z2m, z2p, z3m, z3p
  REAL(KIND=8) zarea, zmm, zmp, zpm, zpp, zshift, zz3
  INTEGER   n2m, n2p, n3m, n3p
  INTEGER   i2m, i2p, i3m, i3p
  INTEGER   n2old, n2new, n3old, n3new
  INTEGER   j2,j3
  dimension  uold(n2old,n3old), x2old(n2old), x3old(n3old)
  dimension  unew(n2new,n3new), x2new(n2new), x3new(n3new)
  dimension  x2m(n2new), x2p(n2new), x3m(n3new), x3p(n3new)
  dimension  n2m(n2new), n2p(n2new), n3m(n3new), n3p(n3new)
!---------------------------------------------------------------------
!               1.         Set geometry coefficients
!                   1.1      X2 coefficients
  do j2=1,n2new
    i2p=2
    do while((x2new(j2).gt.x2old(i2p)).and.(i2p.lt.n2old))
      i2p=i2p+1
    enddo
    i2m=i2p-1
    n2m(j2)=i2m
    n2p(j2)=i2p
    x2m(j2)=(x2new(j2)-x2old(i2m))
    x2p(j2)=(x2old(i2p)-x2new(j2))
  enddo
!                   1.2      X3 coefficients
  do j3=1,n3new
    i3p=2
    zz3=x3new(j3)+zshift
    if(zz3.gt.6.2831854d0) zz3=zz3-6.2831854d0
    do while((zz3.gt.x3old(i3p)).and.(i3p.lt.n3old))
      i3p=i3p+1
    enddo
    i3m=i3p-1
    n3m(j3)=i3m
    n3p(j3)=i3p
    x3m(j3)=(zz3-x3old(i3m))
    x3p(j3)=(x3old(i3p)-zz3)
  enddo
!---------------------------------------------------------------------
!               2.         Interpolate boundary values
  do j3=1,n3new
    i3m=n3m(j3)
    i3p=n3p(j3)
    z3m=x3m(j3)
    z3p=x3p(j3)
    do j2=1,n2new
      i2m=n2m(j2)
      i2p=n2p(j2)
      z2m=x2m(j2)
      z2p=x2p(j2)
      zarea=(z2m+z2p)*(z3m+z3p)
      zmm=z2p*z3p/zarea
      zmp=z2p*z3m/zarea
      zpm=z2m*z3p/zarea
      zpp=z2m*z3m/zarea
      unew(j2,j3)=zmm*uold(i2m,i3m)+zmp*uold(i2m,i3p) &
                 +zpm*uold(i2p,i3m)+zpp*uold(i2p,i3p)
    enddo
  enddo
!---------------------------------------------------------------------
RETURN
END SUBROUTINE INTERP
