;---------------------------------------------------------------
pro cme_bnd, x2, x3, var, var_levels, var_colors, pxrange, pyrange, $
  title=title, $
  color_grd=color_grd, color_txt=color_txt, charsize=charsize, $
  xrange=xrange, yrange=yrange, xlabel=xlabel, ylabel=ylabel
;---------------------------------------------------------------
  varmin=min(var,max=varmax)
;---------------------------------------------------------------
  idim2=size(x2)  &  n2=idim2(1)
  idim3=size(x3)  &  n3=idim3(1)
  xx=fltarr(n3,n2)
  yy=fltarr(n3,n2)
  zz=fltarr(n3,n2)
  for j2=0,n2-1 do begin
    for j3=0,n3-1 do begin
      xx(j3,j2)=x3(j3)
      yy(j3,j2)=180.-x2(j2)
      zz(j3,j2)=var(j2,j3)
    endfor
  endfor
;---------------------------------------------------------------
  zmin=var_levels(0)-0.1*var_levels(0)
  zmin=varmin-0.1*varmin
; for j2=0,n2-1 do begin
;   zz(0,j2)=zmin
;   zz(n3-1,j2)=zmin
; endfor
; for j3=0,n3-1 do begin
;   zz(j3,0)=zmin
;   zz(j3,n2-1)=zmin
; endfor
;---------------------------------------------------------------
  position_set, x3, x2, pxx, pyy, xrange=xrange, yrange=yrange,$
    pxrange=pxrange, pyrange=pyrange, position=position
;---------------------------------------------------------------
  contour,zz,xx,yy,/fill,/noerase, $
    levels=var_levels,c_colors=var_colors, $
    xrange=xrange,xstyle=5,yrange=yrange,ystyle=5, $
    position=position,/norm
;---------------------------------------------------------------
  zx000=position(0)
  zx100=position(2)
  zx025=0.75*zx000+0.25*zx100
  zx050=0.50*zx000+0.50*zx100
  zx075=0.25*zx000+0.75*zx100
  zy000=position(1)
  zy100=position(3)
  zy025=0.75*zy000+0.25*zy100
  zy050=0.50*zy000+0.50*zy100
  zy075=0.25*zy000+0.75*zy100
;---------------------------------------------------------------
  plots,[zx000,zx100],[zy000,zy000],color=color_grd,/norm
  plots,[zx000,zx100],[zy025,zy025],color=color_grd,/norm
  plots,[zx000,zx100],[zy050,zy050],color=color_grd,/norm
  plots,[zx000,zx100],[zy075,zy075],color=color_grd,/norm
  plots,[zx000,zx100],[zy100,zy100],color=color_grd,/norm
;---------------------------------------------------------------
  plots,[zx000,zx000],[zy000,zy100],color=color_grd,/norm
  plots,[zx025,zx025],[zy000,zy100],color=color_grd,/norm
  plots,[zx050,zx050],[zy000,zy100],color=color_grd,/norm
  plots,[zx075,zx075],[zy000,zy100],color=color_grd,/norm
  plots,[zx100,zx100],[zy000,zy100],color=color_grd,/norm
;---------------------------------------------------------------
;Character size
  if(n_elements(charsize) eq 0) then charsize=1.0
  xyouts,'W',charsize=-charsize,width=pxchar,/normal
  pychar=pxchar*!d.x_size/!d.y_size
;---------------------------------------------------------------
  xyouts,zx050,zy100+3.0*pychar,title, $
    color=color_txt,align=0.5,/norm,charsize=charsize
  wrange=[zx000,zy100+1.0*pychar,zx100,zy100+2.0*pychar]
  color_bar,wrange,levels=var_levels,c_colors=var_colors, $
    /fill,color=color_txt, $
    title=' ',charsize=charsize, $
    min=strmid(strtrim(string(min(var_levels)),2),0,4), $
    max=strmid(strtrim(string(max(var_levels)),2),0,4)
;---------------------------------------------------------------
  if(keyword_set(ylabel)) then begin
    xyouts,zx000-1.0*pxchar,zy100-0.5*pychar,'0!U0!N', $
      color=color_txt,align=1.0,charsize=charsize,/norm
    xyouts,zx000-1.0*pxchar,zy050-0.5*pychar,'90!U0!N', $
      color=color_txt,align=1.0,charsize=charsize,/norm
    xyouts,zx000-1.0*pxchar,zy000-0.5*pychar,'180!U0!N', $
      color=color_txt,align=1.0,charsize=charsize,/norm
  endif
;---------------------------------------------------------------
  if(keyword_set(xlabel)) then begin
    xyouts,zx000,zy000-2.0*pychar,'0!U0!N', $
      color=color_txt,align=0.0,charsize=charsize,/norm
    xyouts,zx050,zy000-2.0*pychar,'180!U0!N', $
      color=color_txt,align=0.5,charsize=charsize,/norm
    xyouts,zx100,zy000-2.0*pychar,'360!U0!N', $
      color=color_txt,align=1.0,charsize=charsize,/norm
  endif
;---------------------------------------------------------------
end
