;=======================================================================
PRO PLOT_AMB3, dir_proj, name_proj, name_bnd, name_grd
;-----------------------------------------------------------------------
  cloud='no'
  polarity='yes'
;-----------------------------------------------------------------------
  v_min=250  &  v_max=750
  d_min=0    &  d_max=1500
  t_min=0    &  t_max=1.2
  b_min=-350 &  b_max=350
;-----------------------------------------------------------------------
  name_case='case.'+name_bnd+'.'+name_grd
  file_bnd=dir_proj+'/'+name_proj+'/'+name_case+'/bnd.nc'
  file_img=dir_proj+'/'+name_proj+'/'+name_case+'/case.png'
;-----------------------------------------------------------------------
;Units
  vux1=1.496e11   &  vux2=!dtor  &  vux3=!dtor
  vutime=3600e0   &  vud=1e6  &  vuv=1e3  &  vut=1e6  &  vub=1e-9
;-----------------------------------------------------------------------
;Constants
  ck=1.38054e-23
  cmass=1.67239e-27
  cmu=1.2566e-6
  xalpha=0.
  xmass=(1e0+4e0*xalpha)*cmass
  rgas=((2e0+3e0*xalpha)/(1e0+4e0*xalpha))*(ck/cmass)
  gamma=1.5
  gammam=gamma-1e0
;=======================================================================
;READ IN RESULTING DATA
;-----------------------------------------------------------------------
  fileid=ncdf_open(file_bnd,/nowrite)
  ncdf_varget,fileid,0,x1
  ncdf_varget,fileid,1,x2
  ncdf_varget,fileid,2,x3
  ncdf_varget,fileid,3,x1h
  ncdf_varget,fileid,4,x2h
  ncdf_varget,fileid,5,x3h
  ncdf_varget,fileid,6,time
  ncdf_varget,fileid,9,d
  ncdf_varget,fileid,10,t
  ncdf_varget,fileid,11,v1
  ncdf_varget,fileid,12,v2
  ncdf_varget,fileid,13,v3
  ncdf_varget,fileid,14,b1
  ncdf_varget,fileid,15,b2
  ncdf_varget,fileid,16,b3
  if(cloud eq 'yes') then begin
    if(polarity eq 'yes') then begin
      ncdf_varget,fileid,17,dp
      ncdf_varget,fileid,18,bp
    endif else begin
      ncdf_varget,fileid,17,dp
    endelse
  endif else begin
    if(polarity eq 'yes') then begin
      ncdf_varget,fileid,17,bp
    endif
  endelse
  ncdf_close,fileid
;-----------------------------------------------------------------------
  idim=size(d)
  nh2=idim(1)
  nh3=idim(2)
;=======================================================================
;IMAGE CREATION AND DISPLAY
;-----------------------------------------------------------------------
  set_plot,'Z'
  !y.minor=2
;-----------------------------------------------------------------------
;Contour levels
  d_nlevels=14
  t_nlevels=14
  v_nlevels=14
  b_nlevels=14
;-----------------------------------------------------------------------
  v_levels=v_min+(v_max-v_min)*findgen(v_nlevels)/float(v_nlevels-1)
  b_levels=b_min+(b_max-b_min)*findgen(b_nlevels)/float(b_nlevels-1)
  d_levels=d_min+(d_max-d_min)*findgen(d_nlevels)/float(d_nlevels-1)
  t_levels=t_min+(t_max-t_min)*findgen(t_nlevels)/float(t_nlevels-1)
;-----------------------------------------------------------------------
  x2range=[0,180]
  x3range=[0,360]
  vrange=[v_min,v_max]
  brange=[b_min,b_max]
  drange=[d_min,d_max]
  trange=[t_min,t_max]
;-----------------------------------------------------------------------
;Modify the color table
  loadct,0
  tvlct,r,g,b,/get
;-----------------------------------------------------------------------
;Modify the color table
  r(00:13)=[000,124,134,144,154,164,174,184,194,204,214,224,234,244]
  g(00:13)=[000,124,134,144,154,164,174,184,194,204,214,224,234,244]
  b(00:13)=[000,124,134,144,154,164,174,184,194,204,214,224,234,244]
  r(14:27)=[000,000,000,000,000,125,175,255,255,255,255,255,150,255]
  g(14:27)=[000,150,255,255,255,255,255,255,200,150,100,000,000,255]
  b(14:27)=[255,255,255,150,000,000,000,000,000,000,000,000,000,255]
  r(28:41)=[200,210,220,230,240,250,255,255,255,255,255,255,255,255]
  g(28:41)=[000,000,000,020,040,080,100,120,140,160,180,200,220,255]
  b(28:41)=[000,000,000,000,000,000,000,000,040,080,120,160,200,255]
  r(42:55)=[000,000,000,000,000,000,255,255,255,255,225,200,150,255]
  g(42:55)=[000,000,000,150,200,255,255,200,150,100,000,000,000,255]
  b(42:55)=[150,200,255,255,255,255,000,000,000,000,000,000,000,255]
  tvlct,r,g,b
;-----------------------------------------------------------------------
  color_black=0
  color_white=55
  color_red=35
  v_colors=[14,15,16,17,18,19,20,21,22,23,24,25,26]
  b_colors=[42,43,44,45,46,47,48,49,50,51,52,53,54]
  d_colors=[14,15,16,17,18,19,20,21,22,23,24,25,26]
  t_colors=[28,29,30,31,32,33,34,35,36,37,38,39,40]
  color_grd=color_white
  color_txt=color_white
!p.background=color_white
erase
color_grd=color_black
color_txt=color_black
;-----------------------------------------------------------------------
;Character sizes
  charsize=0.8
;-----------------------------------------------------------------------
;Time level
  case n_elements(time) of
    1: itime=0
    2: itime=0
    3: itime=0
    else: itime=1
  endcase
;-----------------------------------------------------------------------
  x1=x1(itime)/vux1
  x2=x2(*,itime)/vux2
  x3=x3(*,itime)/vux3
  x1h=x1h(itime)/vux1
  x2h=x2h(*,itime)/vux2
  x3h=x3h(*,itime)/vux3
  dd=reform(d(*,*,itime))/xmass/vud
  tt=reform(t(*,*,itime))/vut
  vv=reform(v1(*,*,itime))/vuv
  bb=reform(b1(*,*,itime))/vub
  if(polarity eq 'yes') then pp=reform(bp(*,*,itime))
  cc=sqrt(gamma*rgas*vut*tt)/vuv+abs(vub*bb)/sqrt(cmu*vud*xmass*dd)/vuv
  cs=sqrt(gamma*rgas*vut*tt)/vuv
  ca=abs(vub*bb)/sqrt(cmu*vud*xmass*dd)/vuv
print,'ca',min(ca),max(ca)
print,'cs',min(cs),max(cs)
print,'cc',min(cc),max(cc)
print,'vv',min(vv),max(vv)
print,'v-c',vv(0,0),cc(0,0)
;-----------------------------------------------------------------------
  idim=size(vv)
  i2=idim(1)
  i3=idim(2)
  i2pos=idim(1)/2
  i3pos=idim(2)/2
;-----------------------------------------------------------------------
  dd2=reform(d(i2pos,i3pos,*))/xmass/vud
  tt2=reform(t(i2pos,i3pos,*))/vut
  vv2=reform(v1(i2pos,i3pos,*))/vuv
  bb2=reform(b1(i2pos,i3pos,*))/vub
  if(polarity eq 'yes') then pp2=reform(bp(i2pos,i3pos,*))
  cc2=sqrt(gamma*rgas*vut*tt2)/vuv+abs(vub*bb2)/sqrt(cmu*vud*xmass*dd2)/vuv
;-----------------------------------------------------------------------
  if(polarity eq 'yes') then begin
    idim=size(pp)
    ib2=idim(1)
    ib3=idim(2)
    for j3=0,ib3-1 do begin
      for j2=0,ib2-1 do begin
        if(pp(j2,j3) lt 0.) then bb(j2,j3)=-bb(j2,j3)
      endfor
    endfor
    idim=size(pp2)
    ibt=idim(1)
    for jt=0,ibt-1 do begin
      if(pp2(jt) lt 0.) then bb2(jt)=-bb2(jt)
    endfor
  endif
;-----------------------------------------------------------------------
;Plot-area position
  pxrange_1=[0.060,0.250]
  pxrange_2=[0.302,0.492]
  pxrange_3=[0.544,0.734]
  pxrange_4=[0.786,0.976]
  pyrange_1=[0.140,0.260]
  pyrange_2=[0.340,0.460]
  pyrange_3=[0.540,0.660]
  pyrange_4=[0.740,0.950]
;-----------------------------------------------------------------------
  cme_bnd,x2,x3,vv,v_levels,v_colors,pxrange_1,pyrange_4, $
    title='VELOCITY (km/s)', $
    color_grd=color_grd,color_txt=color_txt,charsize=charsize, $
    xrange=x3range,yrange=x2range,/xlabel,/ylabel
  cme_bnd,x2,x3,dd,d_levels,d_colors,pxrange_2,pyrange_4, $
    title='DENSITY (cm!U-3!N)', $
    color_grd=color_grd,color_txt=color_txt,charsize=charsize, $
    xrange=x3range,yrange=x2range,/xlabel
  cme_bnd,x2,x3,tt,t_levels,t_colors,pxrange_3,pyrange_4, $
    title='TEMPERATURE (MK)', $
    color_grd=color_grd,color_txt=color_txt,charsize=charsize, $
    xrange=x3range,yrange=x2range,/xlabel
  cme_bnd,x2,x3,bb,b_levels,b_colors,pxrange_4,pyrange_4, $
    title='MAGNETIC FIELD (nT)', $
    color_grd=color_grd,color_txt=color_txt,charsize=charsize, $
    xrange=x3range,yrange=x2range,/xlabel
;-----------------------------------------------------------------------
  plot,vv(*,i3pos),title='Velocity vs Theta',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i2-1],xstyle=1, $
    position=[pxrange_1(0),pyrange_3(0),pxrange_1(1),pyrange_3(1)],/norm
  oplot,cc(*,i3pos),color=color_red
  plot,dd(*,i3pos),title='Density vs Theta',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i2-1],xstyle=1, $
    position=[pxrange_2(0),pyrange_3(0),pxrange_2(1),pyrange_3(1)],/norm
  plot,tt(*,i3pos),title='Temperature vs Theta',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i2-1],xstyle=1, $
    position=[pxrange_3(0),pyrange_3(0),pxrange_3(1),pyrange_3(1)],/norm
  plot,bb(*,i3pos),title='Field vs Theta',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i2-1],xstyle=1, $
    position=[pxrange_4(0),pyrange_3(0),pxrange_4(1),pyrange_3(1)],/norm
;-----------------------------------------------------------------------
  plot,vv(i2pos,*),title='Velocity vs Phi',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i3-1],xstyle=1, $
    position=[pxrange_1(0),pyrange_2(0),pxrange_1(1),pyrange_2(1)],/norm
  oplot,cc(i2pos,*),color=color_red
  plot,dd(i2pos,*),title='Density vs Phi',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i3-1],xstyle=1, $
    position=[pxrange_2(0),pyrange_2(0),pxrange_2(1),pyrange_2(1)],/norm
  plot,tt(i2pos,*),title='Temperature vs Phi',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i3-1],xstyle=1, $
    position=[pxrange_3(0),pyrange_2(0),pxrange_3(1),pyrange_2(1)],/norm
  plot,bb(i2pos,*),title='Field vs Phi',/noerase, $
    color=color_black,charsize=charsize,xrange=[0,i3-1],xstyle=1, $
    position=[pxrange_4(0),pyrange_2(0),pxrange_4(1),pyrange_2(1)],/norm
;-----------------------------------------------------------------------
  plot,vv2,title='Velocity vs Time',/noerase, $
    color=color_black,charsize=charsize, $
    position=[pxrange_1(0),pyrange_1(0),pxrange_1(1),pyrange_1(1)],/norm
  oplot,cc2,color=color_red
  plot,dd2,title='Density vs Time',/noerase, $
    color=color_black,charsize=charsize, $
    position=[pxrange_2(0),pyrange_1(0),pxrange_2(1),pyrange_1(1)],/norm
  plot,tt2,title='Temperature vs Time',/noerase, $
    color=color_black,charsize=charsize, $
    position=[pxrange_3(0),pyrange_1(0),pxrange_3(1),pyrange_1(1)],/norm
  plot,bb2,title='Field vs Time',/noerase, $
    color=color_black,charsize=charsize, $
    position=[pxrange_4(0),pyrange_1(0),pxrange_4(1),pyrange_1(1)],/norm
;-----------------------------------------------------------------------
  i2=nh2/2
  i3=nh3/2
  rmin=vux1*max(x1h)/6.96e8
  rmax=215.
  lrmin=strmid(strtrim(string(rmin),2),0,4)
;-----------------------------------------------------------------------
  dtmax1=strmid(strtrim(string(!radeg*(x2h(1)-x2h(0))),2),0,4)
  dtmax2=strmid(strtrim(string(rmin*(x2h(1)-x2h(0))),2),0,4)
  dtmax3=strmid(strtrim(string(rmax*(x2h(1)-x2h(0))),2),0,4)
  dtmin1=strmid(strtrim(string(!radeg*(x2h(i2)-x2h(i2-1))),2),0,4)
  dtmin2=strmid(strtrim(string(rmin*(x2h(i2)-x2h(i2-1))),2),0,4)
  dtmin3=strmid(strtrim(string(rmax*(x2h(i2)-x2h(i2-1))),2),0,4)
  dtmax='dtheta_max='+dtmax1+'!U0!N ('+dtmax2+'R!DS!N at '+lrmin+  $
    ' R!DS!N, '+dtmax3+'R!DS!N at 1 AU)'
  dtmin='dtheta_min='+dtmin1+'!U0!N ('+dtmin2+'R!DS!N at '+lrmin+  $
    ' R!DS!N, '+dtmin3+'R!DS!N at 1 AU)'
  xyouts,0.02,0.06,dtmax,charsize=charsize,color=color_black,align=0.0,/norm
  xyouts,0.02,0.02,dtmin,charsize=charsize,color=color_black,align=0.0,/norm
;-----------------------------------------------------------------------
  dpmax1=strmid(strtrim(string(!radeg*(x3h(1)-x3h(0))),2),0,4)
  dpmax2=strmid(strtrim(string(rmin*(x3h(1)-x3h(0))),2),0,4)
  dpmax3=strmid(strtrim(string(rmax*(x3h(1)-x3h(0))),2),0,4)
  dpmin1=strmid(strtrim(string(!radeg*(x3h(i3)-x3h(i3-1))),2),0,4)
  dpmin2=strmid(strtrim(string(rmin*(x3h(i3)-x3h(i3-1))),2),0,4)
  dpmin3=strmid(strtrim(string(rmax*(x3h(i3)-x3h(i3-1))),2),0,4)
  dpmax='dphi_max='+dpmax1+'!U0!N ('+dpmax2+'R!DS!N at '+lrmin+  $
    ' R!DS!N, '+dpmax3+'R!DS!N at 1 AU)'
  dpmin='dphi_min='+dpmin1+'!U0!N ('+dpmin2+'R!DS!N at '+lrmin+  $
    ' R!DS!N, '+dpmin3+'R!DS!N at 1 AU)'
  xyouts,0.98,0.06,dpmax,charsize=charsize,color=color_black,align=1.0,/norm
  xyouts,0.98,0.02,dpmin,charsize=charsize,color=color_black,align=1.0,/norm
;-----------------------------------------------------------------------
  xyouts,0.02,0.97,'PROJECT: '+name_proj,charsize=charsize, $
    color=color_black,align=0.0,/norm
  zcase=strsplit(name_case,'.',/extract)
  if(n_elements(zcase) eq 3) then begin
    zzcase=zcase(1)+'.'+zcase(2)
  endif else begin
    zzcase=zcase(1)+'.'+zcase(2)+'.'+zcase(3)
  endelse
  xyouts,0.98,0.97,'CASE: '+zzcase,charsize=charsize, $
    color=color_black,align=1.0,/norm
;-----------------------------------------------------------------------
  write_png,file_img,tvrd(),r,g,b
;-----------------------------------------------------------------------
end
